#include "scr.h"
#include "pm.h"
#include "task.h"

void bootinfo(dword magic, struct multiboot_info *mbi);


int main(dword magic, struct multiboot_info *mbi)
{
 
 init_video();
 bootinfo(magic,mbi);
 gdt_install();
 idt_install();
 isrs_install();
 irq_install();
 
 enable();		//Enable IRQs
 

 timer_install();

 init_task();

 printf("\ndone\n");

 far_jmp(0x30);

 printf("done again\n");

 for(;;);
}



void bootinfo(dword magic, struct multiboot_info *mbi)
{
 char *device[] = { "floppy A", "hard disk"};
     // is magic number valid?
  if(magic != multiboot_magic)
   {
    printf("not grub\n");
    printf("Invalid magic number %x\n", magic);
   }
  else
   {
    printf("grub\n");
   }

     // if bit 1 of flags is set, then memory info is available
  if (mbi->flags & 1)
   {
    printf ("Lower memory = %uKB\n",(unsigned) mbi->mem_lower);
    printf ("Upper memory = %uKB\n", (unsigned) mbi->mem_upper);
   }
     // if bit 2 of flags is set, then boot device info is available
  char bootdvc = ((unsigned) mbi->boot_device >> 24) & 0xf;
  char *boot = (bootdvc)?device[1]:device[0];
  if (mbi->flags & 2)
   printf ("Boot device = %s\n", boot);
}


